Scala Standard Library2.13.0 < Back


# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.collection.parallel` - Parallel collections (scala-parallel-collections.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package compat
  Definition Classes
    scala
- Platform

o

scala.compat

# Platform

###

#### object Platform

Annotations
  @deprecated
Deprecated

  (Since version 2.13.0) Will be removed in Scala 2.14.0.

Source
  Platform.scala

Linear Supertypes
AnyRef, Any

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Platform
2. AnyRef
3. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Deprecated Type Members

1.  type ConcurrentModificationException = java.util.ConcurrentModificationException

   This is a type alias for `java.util.ConcurrentModificationException`, which may be thrown by methods that detect an invalid modification of an object.

   This is a type alias for `java.util.ConcurrentModificationException`, which may be thrown by methods that detect an invalid modification of an object. For example, many common collection types do not allow modifying a collection while it is being iterated over.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `java.util.ConcurrentModificationException` instead.

2.  type StackOverflowError = java.lang.StackOverflowError

   Thrown when a stack overflow occurs because a method or function recurses too deeply.

   Thrown when a stack overflow occurs because a method or function recurses too deeply.

   On the JVM, this is a type alias for `java.lang.StackOverflowError`, which itself extends `java.lang.Error`. The same rules apply to catching a `java.lang.Error` as for Java, that it indicates a serious problem that a reasonable application should not try and catch.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `java.lang.StackOverflowError` instead.

### Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
4.  final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

5.  def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
   Note

     not specified by SLS as a member of AnyRef

6.  final def eq(arg0: AnyRef): Boolean

   Tests whether the argument (`that`) is a reference to the receiver object (`this`).

   Tests whether the argument (`that`) is a reference to the receiver object (`this`).

   The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

   - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
   - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
   - `null.eq(null)` returns `true`.

   When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

   returns

     `true` if the argument is a reference to the receiver object; `false` otherwise.

   Definition Classes
     AnyRef
7.  def equals(arg0: AnyRef): Boolean

   The equality method for reference types.

   The equality method for reference types. Default implementation delegates to `eq`.

   See also `equals` in scala.Any.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
8.  def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.Throwable])
   Note

     not specified by SLS as a member of AnyRef

9.  final def getClass(): Class[_ <: AnyRef]

   Returns the runtime class representation of the object.

   Returns the runtime class representation of the object.

   returns

     a class object corresponding to the runtime type of the receiver.

   Definition Classes
     AnyRef → Any
   Annotations
     @native()
10.  def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
11.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
12.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
13.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

14.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

15.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
16.  def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any
17.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
18.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
19.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  val EOL: String

   The default line separator.

   The default line separator.

   On the JVM, this is equivalent to calling the method: `java.lang.System.lineSeparator`

   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `java.lang.System#lineSeparator` instead.

2.  def arrayclear(arr: Array[Int]): Unit

   Assigns the value of 0 to each element in the array.

   Assigns the value of 0 to each element in the array.

   arr

     A non-null Array[Int].

   Annotations
     @inline() @deprecated
   Deprecated

     (Since version 2.13.0) Use `java.util.Arrays#fill` instead.

   Exceptions thrown

     `java.lang.NullPointerException` If `arr` is `null`.

3.  def arraycopy(src: AnyRef, srcPos: Int, dest: AnyRef, destPos: Int, length: Int): Unit

   Copies `length` elements of array `src` starting at position `srcPos` to the array `dest` starting at position `destPos`.

   Copies `length` elements of array `src` starting at position `srcPos` to the array `dest` starting at position `destPos`. If `src`==`dest`, the copying will behave as if the elements copied from `src` were first copied to a temporary array before being copied back into the array at the destination positions.

   src

     A non-null array as source for the copy.

   srcPos

     The starting index in the source array.

   dest

     A non-null array as destination for the copy.

   destPos

     The starting index in the destination array.

   length

     The number of elements to be copied.

   Annotations
     @inline() @deprecated
   Deprecated

     (Since version 2.13.0) Use `java.lang.System#arraycopy` instead.

   Exceptions thrown

     `java.lang.ArrayStoreException` If either `src` or `dest` are not of type [java.lang.Array]; or if the element type of `src` is not compatible with that of `dest`.

     `java.lang.IndexOutOfBoundsException` If either `srcPos` or `destPos` are outside of the bounds of their respective arrays; or if `length` is negative; or if there are less than `length` elements available after `srcPos` or `destPos` in `src` and `dest` respectively.

     `java.lang.NullPointerException` If either `src` or `dest` are `null`.

4.  def collectGarbage(): Unit

   Runs the garbage collector.

   Runs the garbage collector.

   This is a request that the underlying JVM runs the garbage collector. The results of this call depends heavily on the JVM used. The underlying JVM is free to ignore this request.

   Annotations
     @inline() @deprecated
   Deprecated

     (Since version 2.13.0) Use `java.lang.System#gc` instead.

5.  def createArray(elemClass: Class[_], length: Int): AnyRef

   Creates a new array of the specified type and given length.

   Creates a new array of the specified type and given length.

   Note that if `elemClass` is a subclass of scala.AnyVal then the returned value is an Array of the corresponding java primitive type. For example, the following code `scala.compat.Platform.createArray(classOf[Int], 4)` returns an array of the java primitive type `int`.

   For a scala.AnyVal array, the values of the array are set to 0 for numeric value types (scala.Double, scala.Float, scala.Long, scala.Int, scala.Char, scala.Short, and scala.Byte), and `false` for scala.Boolean. Creation of an array of type scala.Unit is not possible.

   For subclasses of scala.AnyRef, the values of the array are set to `null`.

   The caller must cast the returned value to the correct type.

   elemClass

     the `Class` object of the component type of the array

   length

     the length of the new array.

   returns

     an array of the given component type as an `AnyRef`.

   Annotations
     @inline() @deprecated
   Deprecated

     (Since version 2.13.0) Use `java.lang.reflect.Array#newInstance` instead.

   Example:

   1.     val a = scala.compat.Platform.createArray(classOf[Int], 4).asInstanceOf[Array[Int]] // returns Array[Int](0, 0, 0, 0)

   Exceptions thrown

     `java.lang.IllegalArgumentException` if componentType is scala.Unit or `java.lang.Void.TYPE`

     `java.lang.NegativeArraySizeException` if the specified length is negative

     `java.lang.NullPointerException` If `elemClass` is `null`.

6.  def currentTime: Long

   The current time in milliseconds.

   The current time in milliseconds. The time is counted since 1 January 1970 UTC.

   Note that the operating system timer used to obtain this value may be less precise than a millisecond.

   Annotations
     @inline() @deprecated
   Deprecated

     (Since version 2.13.0) Use `java.lang.System#currentTimeMillis` instead.

7.  def defaultCharsetName: String

   The name of the default character set encoding as a string

   The name of the default character set encoding as a string

   Annotations
     @inline() @deprecated
   Deprecated

     (Since version 2.13.0) Use `java.nio.charset.Charset.defaultCharset#name` instead.

8.  def getClassForName(name: String): Class[_]

   Returns the `Class` object associated with the class or interface with the given string name using the current `ClassLoader`.

   Returns the `Class` object associated with the class or interface with the given string name using the current `ClassLoader`. On the JVM, invoking this method is equivalent to: `java.lang.Class.forName(name)`

   For more information, please see the Java documentation for java.lang.Class.

   name

     the fully qualified name of the desired class.

   returns

     the `Class` object for the class with the specified name.

   Annotations
     @inline() @deprecated
   Deprecated

     (Since version 2.13.0) Use `java.lang.Class#forName` instead.

   Example:

   1.     val a = scala.compat.Platform.getClassForName("java.lang.Integer")  // returns the Class[_] for java.lang.Integer

   Exceptions thrown

     `java.lang.ClassNotFoundException` if the class cannot be located

     `java.lang.ExceptionInInitializerError` if the initialization provoked by this method fails

     `java.lang.LinkageError` if the linkage fails

### Inherited from AnyRef

### Inherited from Any

### Ungrouped